console.redhat.com CloudEvents for Python
=======================================

This repo contains Python bindings of the JSON schema definitions for events
generated by console.redhat.com

Getting started
---------------

`crc-event-schemas` is available on [PyPi](https://pypi.org/).
You can install using [pip](https://pip.pypa.io/en/stable/).

```bash
$ pip install crc-event-schemas
```

Layout
------

* `api`: Defines a submodule with the current version of console.redhat.com
  CloudEvents.
* `examples`: Contains examples on how to use this library.
* `event_schemas`: Python bindings for console.redhat.com cloud events.

Generating code
---------------

The [generate.js](./scripts/generate.js) script generates the Python code.

This script is executed on any push to our main branch, ensuring it never goes out 
of sync.

Releasing a new version
-----------------------

The release process works with 
[release-please-action](https://github.com/google-github-actions/release-please-action).
You can head to their 
[documentation](https://github.com/google-github-actions/release-please-action) 
to learn more about it, but in a nutshell:
 - Uses [Conventional Commits](https://www.conventionalcommits.org/en/v1.0.0/) 
 - Creates a PR when there is something to be released (patch, minor or major).
   Once that PR is merged, a new release occurs. 

The release is published to [PyPi](https://pypi.org/).

Docs
----

Docs are automatically generated and hosted on GitHub pages: 
https://redhatinsights.github.io/event-schemas-python/.
